package org.vendor.console.tools;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.WorkbenchEncoding;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.internal.console.ConsoleView;
import org.eclipse.ui.part.IPage;
import org.vendor.console.Console;
import org.vendor.console.tools.Messages;

public class ViewSaveActionDelegate implements IViewActionDelegate {
  public void run(IAction action) {
    IWorkbench workbench = PlatformUI.getWorkbench();
    if (workbench == null)
      return; 
    IWorkbenchWindow activeWorkbenchWindow = workbench.getActiveWorkbenchWindow();
    if (activeWorkbenchWindow == null)
      return; 
    IWorkbenchPage activePage = activeWorkbenchWindow.getActivePage();
    if (activePage == null)
      return; 
    IViewPart findView = activePage.findView("org.eclipse.ui.console.ConsoleView");
    if (!(findView instanceof ConsoleView))
      return; 
    ConsoleView consoleView = (ConsoleView)findView;
    IPage currentPage = consoleView.getCurrentPage();
    if (currentPage == null)
      return; 
    String dest = null;
    Control control = currentPage.getControl();
    IConsole iConsole = consoleView.getConsole();
    if (control == null)
      return; 
    if (iConsole instanceof Console) {
      Console console = (Console)iConsole;
      File backup = console.getBackup();
      long contentLength = backup.length();
      if (contentLength == 0L) {
        MessageDialog.openWarning(control.getShell(), Messages.ViewSaveActionDelegate_console_Warning, Messages.ViewSaveActionDelegate_noContent);
        return;
      } 
      FileDialog fileDialog = new FileDialog(control.getShell(), 8192);
      fileDialog.setFilterExtensions(new String[] { "*.txt", "*.log", "*.*" });
      dest = fileDialog.open();
      if (dest == null)
        return; 
      File file = new File(dest);
      if (file.exists()) {
        boolean openConfirm = MessageDialog.openConfirm(control
            .getShell(), Messages.ViewSaveActionDelegate_confirm, Messages.ViewSaveActionDelegate_fileExists);
        if (!openConfirm)
          return; 
      } 
      FileInputStream in = null;
      FileOutputStream out = null;
      try {
        in = new FileInputStream(backup);
        out = new FileOutputStream(new File(dest));
        int read = 0;
        byte[] buffer = new byte[102400];
        while (contentLength > 0L && (read = in.read(buffer)) > 0)
          out.write(buffer, 0, read); 
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      } finally {
        try {
          if (in != null)
            in.close(); 
        } catch (IOException e) {
          e.printStackTrace();
        } 
        try {
          if (out != null)
            out.close(); 
        } catch (IOException e) {
          e.printStackTrace();
        } 
      } 
    } else {
      if (!(control instanceof StyledText))
        return; 
      StyledText text = (StyledText)control;
      String content = text.getText();
      if (content.length() == 0) {
        MessageDialog.openWarning(control.getShell(), Messages.ViewSaveActionDelegate_console_Warning, Messages.ViewSaveActionDelegate_noContent);
        return;
      } 
      FileDialog fileDialog = new FileDialog(control.getShell(), 8192);
      fileDialog.setFilterExtensions(new String[] { "*.txt", "*.log", "*.*" });
      dest = fileDialog.open();
      if (dest == null)
        return; 
      File file = new File(dest);
      if (file.exists()) {
        boolean openConfirm = MessageDialog.openConfirm(control
            .getShell(), Messages.ViewSaveActionDelegate_confirm, Messages.ViewSaveActionDelegate_fileExists);
        if (!openConfirm)
          return; 
      } 
      FileOutputStream out = null;
      try {
        out = new FileOutputStream(new File(dest));
        out.write(content.getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      } finally {
        try {
          if (out != null)
            out.close(); 
        } catch (IOException e) {
          e.printStackTrace();
        } 
      } 
    } 
  }
  
  public void selectionChanged(IAction action, ISelection selection) {}
  
  public void init(IViewPart view) {}
}
